#include <stdio.h>
#include <stdlib.h>
#include "DataStruct.h"
#include "consts.h"
#include "function.h"
#include "GOBAN.h"
#include "GSL.h"
#include "Point.h"
#include "Rate.h"


// ՗̈mۂ
Goban* Goban_makeNew(void){
	Goban* new_goban;
	if ((new_goban = (Goban*)malloc(sizeof(Goban)))==NULL){
		fprintf (stderr, "#malloc() error 16 in GOBAN.c\n");
		getchar();
		exit(1);
	}
	new_goban->gsl = GSL_makeNew();
	new_goban->rate = Rate_makeNew();
	new_goban->ptable = Point_makeNew();

	return new_goban;
}

// ՂRs[
void Goban_copy(Goban* org_goban, Goban* new_goban){
	GSL_copy(org_goban->gsl, new_goban->gsl);
	Point_copy(org_goban->ptable, new_goban->ptable);
	Rate_copy(org_goban->rate, new_goban->rate);

	new_goban->agehama[BLACK] = org_goban->agehama[BLACK];
	new_goban->agehama[WHITE] = org_goban->agehama[WHITE];
	new_goban->turncolor = org_goban->turncolor;
	new_goban->cd1LastPoint = org_goban->cd1LastPoint;
	new_goban->cd1BeforeLastPoint = org_goban->cd1BeforeLastPoint;

	return;
}

// pՂ
void Goban_initialize(Goban* goban){
	GSL_initialize(goban->gsl);
	Point_initialize(goban->ptable);
	Rate_initialize(goban->rate);

	goban->agehama[BLACK] = 0;
	goban->agehama[WHITE] = 0;
	goban->turncolor = BLACK;
	goban->cd1LastPoint = OOB;
	goban->cd1BeforeLastPoint = OOB;

	return;
}


// Ղ폜
void Goban_delete(Goban* goban){
	GSL_delete(goban->gsl);
	Point_delete(goban->ptable);
	Rate_delete(goban->rate);

	free(goban); goban = NULL;

	return;
}

// ݂̎vl󋵂GoGuigfxR}hŏo
void printTerritoryByGfx(Goban* goban, FILE* stream){
	Coordinate1d xy;
	Coordinate2d x, y;

	if (!g_iPlayCounter){
		fprintf (stream, "\n");
		return;
	}
	// n̊m
	fprintf (stream, "INFLUENCE");
	for (y=1; y<=DEFAULT_BANSIZE; y++){
		for (x=1; x<=DEFAULT_BANSIZE; x++){
			xy = getXY(x, y);
			fprintf (stream, " %c%d %f", getXGoguifromKasumi(x), getYGoguifromKasumi(y), (double)g_iTerritoryOwnedByBlack[xy]/(double)g_iPlayCounter*2-1.0);
		}
	}
	fprintf (stream, "\n");
	fflush(stream);
}
