#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "consts.h"
#include "function.h"
#include "DataStruct.h"
#include "GS.h"

// TCY1̘A̍쐬
void GS_initialize(GS gs[], int id, int XY, int color){
	int i;
#if DEBUG
#if PRINT
	if (id < 0 || id >= MAXGSNUM)
		fprintf (stderr, "#Iterator error 16 in GS.c\n");
#endif
#endif
	// lݒ
	gs[id].id = id;
	gs[id].color = color;
	gs[id].headstone = XY;
	gs[id].tailstone = XY;
	gs[id].size = 1;
	gs[id].damesize = 0;
	for (i=0; i<DEFAULT_BANSIZE; i++){
		gs[id].dameboard[i]=0;
	}
}


// A̖ ̈J͂Ȃ AIDԂ
void GS_reset(GS* gs){
	int i;
	for (i=0; i<DEFAULT_BANSIZE; i++){
		gs->dameboard[i] = 0;
	}
	gs->id = INVALID_GSID;
}

// _ǉ gs̃_{[hXY_ƂĒǉ
void GS_addDame(Coordinate1d XY, GS* gs){
	Coordinate2d x; // _Wx
	Coordinate2d y; // _Wy

	x = getX(XY);
	y = getY(XY);

#if DEBUG
#if PRINT
	if (x <= 0 || x > DEFAULT_BANSIZE)
		fprintf (stderr, "#Iterator error 52 in GS.c\n");
	if (y <= 0 || y > DEFAULT_BANSIZE)
		fprintf (stderr, "#Iterator error 54 in GS.c\n");
#endif
#endif
	// ysxɊɃ_Ȃ 2i\LȂłȂ(_;)
	if (gs->dameboard[y-1] & (1<<(DEFAULT_BANSIZE-x))){ // nor0_ƂĂĂ
		//ɎĂ̂ŒǉI
		return;
	}
	// rbg𗧂Ăă_ǉ
	else{		
		gs->dameboard[y-1] = gs->dameboard[y-1] | 1<<(DEFAULT_BANSIZE-x);
		gs->damesize++;
		return;
	}
}

// _폜
void GS_removeDame(Coordinate1d XY, GS* gs){
	Coordinate2d x; // _Wx
	Coordinate2d y; // _Wy

	x = getX(XY);
	y = getY(XY);

#if DEBUG
#if PRINT
	if (x <= 0 || x > DEFAULT_BANSIZE)
		fprintf (stderr, "#Iterator error 81 in GS.c\n");
	if (y <= 0 || y > DEFAULT_BANSIZE)
		fprintf (stderr, "#Iterator error 83 in GS.c\n");
#endif
#endif
	// ysxɃ_Ă邩 2i\LĂ΁EEE(_;)
	if (gs->dameboard[y-1] & (1<<(DEFAULT_BANSIZE-x))){ // and0łȂ炨@_Ă
		gs->dameboard[y-1] = gs->dameboard[y-1] ^ (1<<(DEFAULT_BANSIZE-x));
		gs->damesize--; // _TCY炷
		return;
	}
	// _ƂĎĂȂȂ牽Ȃ
	// G[R[hH߂ǂ

	return;
}

// A
// oldgsnewgsɉ
GS* GS_connectGS(Goban* goban, GS* oldgs, GS* newgs){
	int i;
	int tmp_dameboard;
	Coordinate1d head_old, tail_old, tmp, tail_new;
	Point* ptable = goban->ptable;

	tail_new = newgs->tailstone;
	head_old = oldgs->headstone;
	tail_old = oldgs->tailstone;

	/*** [begin] |Cge[u ***/
	// oldgs̘AIDnewgŝ̂ɕύX
	for(tmp=head_old; tmp!=EOSL; tmp=ptable[tmp].nextstone){
		ptable[tmp].stringid = newgs->id;
	}

	// newgs̃e[oldgs̃wbhq
	ptable[tail_new].nextstone = head_old;
	// newgs̍Ōoldgs̍ŌɂȂ
	newgs->tailstone = tail_old;

	// TCYZ
	newgs->size += oldgs->size;

	/*** [end] |Cge[u ***/

	/*** [begin] _e[u ***/

	// oldgs_Anewgsɒǉ
	newgs->damesize = 0; // _TCYZbg
	for (i=0; i<DEFAULT_BANSIZE; i++){
		newgs->dameboard[i] = newgs->dameboard[i] | oldgs->dameboard[i];
		// rbg̐グ@int32rbgƂƂ
		if (newgs->dameboard[i]){ // ǂrbgĂiifȂĂǁA80po/secj
			tmp_dameboard = newgs->dameboard[i];
			tmp_dameboard = (tmp_dameboard & 0x55555555)+((tmp_dameboard>>1) & 0x55555555);
			tmp_dameboard = (tmp_dameboard & 0x33333333)+((tmp_dameboard>>2) & 0x33333333);
			tmp_dameboard = (tmp_dameboard & 0x0F0F0F0F)+((tmp_dameboard>>4) & 0x0F0F0F0F);
			tmp_dameboard = (tmp_dameboard & 0x00FF00FF)+((tmp_dameboard>>8) & 0x00FF00FF);
			tmp_dameboard = (tmp_dameboard & 0x0000FFFF)+((tmp_dameboard>>16) & 0x0000FFFF);
			newgs->damesize += tmp_dameboard;
		}
	}

	/*** [end] _e[u ***/
	GS_reset(oldgs);

	return newgs;	
}
