#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <windows.h>
#include "function.h"
#include "DataStruct.h"
#include "main.h"
#include "GSL.h"
#include "GOBAN.h"
#include "GtpEngine2.h"
#include "UCT.h"
#include "Book.h"
#include "Rate.h"

#define PLAY 200000 // _vC[h̃vC

/********** O[oϐ **********/
Goban* g_currentGoban; // ݂̌
Goban* goban; // p

int main(int argc, char* argv[]){
#if DEBUG == TRUE
	srand(1);
#else
	srand((unsigned int) time(NULL)+(int)GetCurrentProcessId());
#endif

	// ̏ݒ
	setup(argc, argv);

	// [eBOf[^ǂݍ
	readRatePattern3x3();
	readRateBorderDistance();
	readRateMoveDistance();
	readRateMCOwner();

	// ՁipՁj̏
	g_emptyGoban = Goban_makeNew();
	Goban_initialize(g_emptyGoban);

	// ۂɎgՏ
	g_currentGoban = Goban_makeNew();
	Goban_copy(g_emptyGoban, g_currentGoban);

	// ftHg̃R~ݒ
	g_dKomi = DFLT_KOMI;

#if DEFAULT_BANSIZE == 19
	// V[PVp^[ɓǂݍ
	readSPattern();
#endif
	// ubNf[^ɓǂݍ
	if (g_bBookUse){
		readBook();
	}

	// [hƂ̃C֐s
	switch (ex_mode){
		case GTP_MODE:
			GTP_main();
			break;
		case RDM_MODE:
			random_main();
			break;
	}

	// J
	Goban_delete(g_currentGoban);
	Goban_delete(g_emptyGoban);

	return 0;
}

// ̏ݒ
void setup(int argc, char* argv[]){
	int i;
	int len;
	FILE* fp;
	char filepath[256];

	// [h̏ݒ
	ex_mode = GTP_MODE;
	mv_mode = TM1_MODE;
	g_iLimitPlayoutNum = DFLT_PLAYOUT_NUM; // 1肠̃vCAEg
	g_dLimitTimeForThink = DFLT_TIME; // 1/1ǂ̎ԁibj
	g_dTimeLeft[BLACK] = g_dTimeLeft[WHITE] = g_dTimeLeftSetting = g_dLimitTimeForThink; // c莞Ԃ̏
	g_iThreadNum = DFLT_THREAD_NUM; // Xbh
	g_bBookUse = BOOK_USE; // ubNDBgp
	g_iModeConsultation = CONSULTATION_USE; // cH
	g_gfx = GFX; // gfxR}ho͂邩
	g_cConsultationMode[0] = '\0';
	sprintf_s (g_rootdir, 256, "%s", ROOT_DIR);

	// spX擾
	len = strlen(argv[0]);
	for (i=len-1; i>=0; i--){
		if (argv[0][i] == DELIM_PATH){
			argv[0][i+1] = '\0';
			strcpy_s (g_rootdir, 256, argv[0]);
			sprintf_s (filepath, 256, "%sMoveDistance1.txt", g_rootdir);
			if (fopen_s(&fp, filepath, "r"))
				sprintf_s (g_rootdir, 256, "%s..\\IGO\\", g_rootdir);
			else
				fclose (fp);
			break;
		}
	}

	// IvV擾
	for (i=1; i<argc; i++){
		// vCAEgݒ
		if (!strcmp(argv[i], "--playout") || !strcmp(argv[i], "-po")){
			mv_mode = PLO_MODE;
			g_iLimitPlayoutNum = atoi(argv[++i]);
		}
		// 1ǂ̎Ԑݒ肵Ƃ́AՂ̃vCAEgݒ
		else if (!strcmp(argv[i], "--playout_time") || !strcmp(argv[i], "-pot")){
			g_iLimitPlayoutNum = atoi(argv[++i]);
		}
		// Ԑݒ Ŝ̎
		else if (!strcmp(argv[i], "--time") || !strcmp(argv[i], "-t")){
			mv_mode = TIM_MODE;
			g_dLimitTimeForThink = atof(argv[++i]);
			g_dLimitTimeForThink -= 0.1;
			g_dTimeLeft[BLACK] = g_dTimeLeft[WHITE] = g_dTimeLeftSetting = g_dLimitTimeForThink; // c莝Ԃ̏
		}
		// Ԑݒ 肠̎ԁ@؂ꕉ
		else if (!strcmp(argv[i], "--time1") || !strcmp(argv[i], "-t1")){
			g_dLimitTimeForThink = atof(argv[++i]);
			mv_mode = TM1_MODE;
		}
		// {ƂȂs[h
		else if (!strcmp(argv[i], "--mode") || !strcmp(argv[i], "-m")){
			if (!strcmp(argv[++i], "gtp")){
				// GTP[h
				ex_mode = GTP_MODE;
			}
			else if (!strcmp(argv[i], "random")){
				// _[h
				ex_mode = RDM_MODE;
			}else{
				fprintf (stderr, "No parameter for argument \"mode\n\"");
			}
		}
		// sXbh
		else if (!strcmp(argv[i], "--thread") || !strcmp(argv[i], "-th")){
			g_iThreadNum = atoi(argv[++i]);
		}
		// ubNDB
		else if (!strcmp(argv[i], "--noBook") || !strcmp(argv[i], "-nb")){
			g_bBookUse = FALSE;
		}
		// c
		else if (!strcmp(argv[i], "--consultation") || !strcmp(argv[i], "-c")){
			g_iModeConsultation = TRUE;
		}
		else if (!strcmp(argv[i], "--consultationmode")){
			g_iModeConsultation = TRUE;
			sprintf_s(g_cConsultationMode, 128, "%s_", argv[++i]);
		}
		// gfxR}h
		else if (!strcmp(argv[i], "-gfx")){
			g_gfx = TRUE;
		}
		else if (!strcmp(argv[i], "-ngfx")){
			g_gfx = FALSE;
		}
	}
}


// S_ɒ
// iÅ{̑xɎgpj
void random_main(void){
	int i, j, tmp;
	Coordinate2d x, y, X, Y;
	Coordinate1d queue[DEFAULT_BANSIZE*DEFAULT_BANSIZE]; // ꏊ
	Coordinate1d tmp_pos;


	fprintf(stderr, "----------Random mode----------\n");

	// lݒ
	for(x=1;x<=DEFAULT_BANSIZE;x++)
		for(y=1;y<=DEFAULT_BANSIZE;y++)
			queue[(x-1)*DEFAULT_BANSIZE+(y-1)] = getXY(x,y);

	// _ɃvC
	for(i=0; i<PLAY; i++){
		// eXgpՍ쐬
		Goban_copy(g_emptyGoban, g_currentGoban);

		// ꏊVbt
		for(j=DEFAULT_BANSIZE*DEFAULT_BANSIZE-1; j>0; j--){
			// Xbvꏊ_Ɍ
			tmp_pos = rand() % j;
			// Xbv
			tmp = queue[j];
			queue[j] = queue[tmp_pos];
			queue[tmp_pos] = tmp;
		}

		// ݂
		for(j=0; j<DEFAULT_BANSIZE*DEFAULT_BANSIZE; j++){
			X = getX(queue[j]);
			Y = getY(queue[j]);

			// 肪
			if(GSL_putStone(g_currentGoban, queue[j], g_currentGoban->turncolor)>=0){
				// Ԍ
				g_currentGoban->turncolor = (g_currentGoban->turncolor+1)%2;
			}
		}
	}
}


// V[PVp^[ɓǂݍ
// sPattern.dat́A[gp^[ɂă\[gĂȂ΂ȂȂiő啪򐔂𒲂ׂ鏈̂ƂŁA̎dl𗘗pĂj
// E~ǂł
void readSPattern(void){
	int i, j, tmpI;
	int pi = OOB;
	FILE* spdat;
	char s[256];
	char* t;
	int iTurningNumCounter=0; // 򐔃JE^[
	int comp;
	Coordinate1d cd1Pos[SPLENGTHp1]; // ꎞIɒ菇(Έʒu)ۑz
	unsigned int uiPattern[SPLENGTHp1]; // ꎞIɒ菇(p^[)ۑz
	int iPos; // zCfbNX
	Sequential* spTurningPointer[TURNING_NUM]; // ꎞISPւ̃|C^ۑz
	int iOldPi;
	int iTp;
	char filepath[256];
	char* next_token;

	// MAX򐔏
	g_iMaxTurningNum=1;
	comp=OOB;

	// tH[}bg
	g_spppSpattern = (Sequential***)malloc(sizeof(Sequential**)*SPNUM);
	for (i=0; i<SPNUM; i++){
		g_spppSpattern[i] = NULL;
	}

	// p^[f[^t@CI[v
	sprintf_s (filepath, 256, "%ssPattern.dat", g_rootdir);
	if (fopen_s(&spdat, filepath, "r")){
		fprintf(stderr, "#can not open %s\n", filepath);
		exit(1);
	}
	// t@Cǂݍ
	while (fgets(s, 256, spdat) != NULL){
		// ꎞۑz񏉊
		iPos^=iPos;

		t = strtok_s(s, ",", &next_token); // [gp^[
		iOldPi = pi;
		pi = atoi(t);
		t = strtok_s(NULL, ":", &next_token);
		// 򂩁H
		if (pi != comp){
			// ܂ŒׂĂ[gp^[ÄmۂĂƕۑ
			// t@Ĉŏ̂Ƃ́AifɂȂȂ
			if (iTurningNumCounter){
				g_spppSpattern[iOldPi] = (Sequential**)malloc(sizeof(Sequential*)*(iTurningNumCounter+1));
				for (j=0; j< iTurningNumCounter; j++){
					g_spppSpattern[iOldPi][j] = spTurningPointer[j];
				}
				// Ԍ
				g_spppSpattern[iOldPi][j] = NULL;
			}
			// 򐔏
			iTurningNumCounter = 1;
			comp = pi;
		}else{
			// 򐔃JEg
			iTurningNumCounter++;
			// ő啪򐔍XV
			if (iTurningNumCounter > g_iMaxTurningNum){
				g_iMaxTurningNum = iTurningNumCounter;
			}
		}
		for (i=0; t!=NULL; i++){
			cd1Pos[iPos] = atoi(t); // ɒׂxW̕ω
			t = strtok_s(NULL, ",", &next_token);
			tmpI = atoi(t); // ɒׂyW̕ω
			cd1Pos[iPos] += tmpI*(DEFAULT_BANSIZE+OOBLNUMx2);
			t = strtok_s(NULL, ",", &next_token);
			tmpI = atoi(t); // ׂ镶ip^[j
			uiPattern[iPos] = tmpI;
			iPos++;			
			t = strtok_s(NULL, ":", &next_token);
		}
		// ꎞIɕۑĂAƃmۂĕۑ
		// ̃|C^ƂƂ͈ꎞIȂ
		iTp = iTurningNumCounter-1;
		spTurningPointer[iTp] = (Sequential*)malloc(sizeof(Sequential)*(iPos+1));
		for (i=0; i<iPos; i++){
			spTurningPointer[iTp][i].XY = cd1Pos[i];
			spTurningPointer[iTp][i].Pattern = uiPattern[i];
		}
		// Ԍ
		spTurningPointer[iTp][i].XY = OOB;
	}
	fclose(spdat);
}
